; Description:  Short program to select a date.  Uses a "ShowDialog"
;               with buttons to increase/decrease the date.
;               Free
;------------------------------------------------------------------

; Return:   True  - if "Ok" chosen.
;           False - if not.
; Use var:  DateVar from calling procedure
;

PROC lSelectDate()

    Private cButtonValue
    DateVar       = today()                  
    cButtonValue  = ""

    SHOWDIALOG "Select date"

        PROC "DialogProc"    
        Trigger "ACCEPT" 

        @5, 10  HEIGHT 9 WIDTH 60
        @1, 13  ?? "Date:"

        ACCEPT 
           @1, 21  
           WIDTH 13
           "D"
           PICTURE "#[#]/#[#]/9#"
           TAG "DateVar" 
        TO DateVar 
        PUSHBUTTON @ 1, 34 WIDTH 5    ;  hit to increase by one
            ""
            OK
            VALUE "UpDateVar"
            TAG   "UpDateVar"
        TO cButtonValue
        PUSHBUTTON @ 2, 34 WIDTH 5    ;  hit to decrease by one
            ""
            OK
            VALUE "DownDateVar"
            TAG   "DownDateVar"
        TO cButtonValue
        PUSHBUTTON @5, 13 WIDTH 12
            "~O~K"
            OK
            DEFAULT
            VALUE "Ok"
        TO cButtonValue
        PUSHBUTTON @ 5, 30 WIDTH 12
            "~C~ancel"
            CANCEL
            VALUE "Cancel"
        TO cButtonValue

    ENDDIALOG  

    if cButtonValue = "Ok" then  
        Return True               
    else                    ;  "Cancel" chosen or hit Escape
        Return False
    endif                
    
ENDPROC

;------------------------------------------------------------------
; Call       :  From lSelectDates()
; Use vars   :  cButtonValue, DateVar - declared in lSelectDates()
; Description:  Increases or decreases dates, BUT STAYS IN Showdialog.
;
PROC DialogProc( TriggerType, TagValue, EventValue, ElementValue)

    if NOT IsAssigned( TagValue ) then
        Return True    
    endif    

    switch
        case cButtonValue = "DownDateVar" :
            if NOT IsBlank( DateVar ) then
                DateVar = DateVar - 1
                resyncControl "DateVar"
            endif            
            Return False             ; to prevent a CLOSE.
        case cButtonValue = "UpDateVar"    :
            if NOT IsBlank( DateVar ) then
                DateVar = DateVar + 1
                resyncControl "DateVar"
            endif            
            Return False 
        otherwise    :
            Return True       
    endswitch 

ENDPROC

;--------------------------------------------------------------------   
DateVar   = today()                  
if NOT lSelectDate( ) then
    Return
endif                
; ... can now use DateVar
